package jtrek.rmi;

import java.rmi.*;
import java.rmi.activation.*;
import java.util.*;

public class FactoryImplementation extends Activatable implements FactoryInterface {
    private int counter;
    private Deactivator deactivator = null;


    public FactoryImplementation(ActivationID id, MarshalledObject data) 
	throws RemoteException {
	super(id, 0);
	this.counter=0;
	System.out.println("Inializing counter value to " + 
			   (new Integer(counter)).toString());
    }
	
    public Object exportObstrekServer() throws RemoteException {
	System.out.println("counter value " + 
			   (new Integer(counter)).toString());
	System.setSecurityManager(new RMISecurityManager());
 	Properties props = new Properties(); 
        props.put("java.security.policy", "http://c-24-4-208-59.client.comcast.net/netrek/policy");

	try {
	    ActivationGroupDesc.CommandEnvironment ace = null; 
	    ActivationGroupDesc exampleGroup = new ActivationGroupDesc(props, ace);
	    ActivationGroupID agi = 
		ActivationGroup.getSystem().registerGroup(exampleGroup);

	    String location = "http://c-24-4-208-59.client.comcast.net/netrek/JTrek.jar";

	    MarshalledObject data = null;
	    ActivationDesc desc = new ActivationDesc(agi, "jtrek.rmi.ObstrekServer", location, data);
	
	    ObstrekServerInterface obs = (ObstrekServerInterface) Activatable.register(desc);
	    System.out.println("Got the stub for the ObstrekServerInterface");
        
	    String remoteObjName = "rmi://c-24-4-208-59.client.comcast.net/ObstrekServer"+counter++;

	    Naming.rebind(remoteObjName, obs);
	    System.out.println("Exported "+remoteObjName);    
	    return remoteObjName;
	} catch (java.lang.Exception e) {
	    System.out.println("Exception caught " + e.getMessage());
	    throw (new RemoteException(e.getMessage()));
	}
    }

    public void deactivate() throws RemoteException
    {
	deactivator = new Deactivator( this, getID() );
	deactivator.start();
    }
}
