package jtrek.rmi;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.net.*;

public interface ObstrekServerInterface extends Remote {
    public byte[] do_RSA(byte[] data) throws RemoteException;
    public InetAddress getByName(String host) throws RemoteException;
    public DatagramPacket udp_socket_receive(DatagramPacket packet) throws RemoteException;
    public boolean udp_socket_is_null() throws RemoteException;
    public void udp_socket_close() throws RemoteException;
    public void udp_socket_set_null() throws RemoteException;
    public void udp_socket_send(DatagramPacket udp_packet) throws RemoteException;
    public void udp_socket_new(int udp_local_port) throws RemoteException;
    public void udp_socket_setSoTimeout(int timeout) throws RemoteException;
    public InetAddress udp_socket_getLocalAddress() throws RemoteException;
    public int udp_socket_getLocalPort() throws RemoteException;

    public void tcp_socket_new(String host, int port) throws RemoteException;
    public void tcp_socket_getOutputStream() throws RemoteException;
    public void tcp_socket_getInputStream() throws RemoteException;
    public boolean tcp_socket_is_null() throws RemoteException;
    public void tcp_socket_close() throws RemoteException;
    public void tcp_socket_set_null() throws RemoteException;
    public InetAddress tcp_socket_getInetAddress() throws RemoteException;
    public int tcp_socket_getPort() throws RemoteException;

    //public tcp_socket_out() throws RemoteException;
    //public tcp_socket_in() throws RemoteException;

    public void tcp_socket_out_write(byte[] b, int off, int len) throws RemoteException;
    public boolean tcp_socket_out_is_null() throws RemoteException;
    public byte[] tcp_socket_in_read(byte[] b, int off, int len) throws RemoteException;
    public int tcp_reader_in_available() throws RemoteException;

    public void server_socket_new(int port, int backlog) throws RemoteException;
    public void server_socket_setSoTimeout(int timeout) throws RemoteException;
    public void assign_tcp_socket_server_socket_accept() throws RemoteException;
    public boolean server_socket_is_null() throws RemoteException;
    public void server_socket_close() throws RemoteException;

    public void deactivate() throws RemoteException;
}
