package jtrek.rsa;

import java.math.BigInteger;

public class RSA
{

    private static String swapEndian(String s)
    {
        char ac[] = s.toCharArray();
        StringBuffer stringbuffer = new StringBuffer(ac.length);
        for(int i = ac.length; (i -= 2) >= 0;)
        {
            stringbuffer.append(ac[i]);
            stringbuffer.append(ac[i + 1]);
        }

        return stringbuffer.toString();
    }

    private static byte[] swapEndian(byte abyte0[])
    {
        byte abyte1[] = new byte[abyte0.length];
        for(int i = 0; i < abyte0.length; i++)
            abyte1[i] = abyte0[abyte0.length - i - 1];

        return abyte1;
    }

    private static byte[] bigIntegerToByteArray(BigInteger biginteger)
    {
        byte abyte0[] = biginteger.toByteArray();
        if(abyte0.length > 32)
        {
            byte abyte1[] = new byte[32];
            System.arraycopy(abyte0, abyte0.length - 32, abyte1, 0, 32);
            abyte0 = abyte1;
        } else
        if(abyte0.length < 32)
        {
            byte abyte2[] = new byte[32];
            System.arraycopy(abyte0, 0, abyte2, 32 - abyte0.length, abyte0.length);
            abyte0 = abyte2;
        }
        return abyte0;
    }

    public static byte[] generateRSAResponse(byte abyte0[])
    {
        byte abyte1[] = new byte[96];
        byte abyte2[] = swapEndian(bigIntegerToByteArray(GLOBAL_KEY));
        System.arraycopy(abyte2, 0, abyte1, 0, 32);
        abyte2 = swapEndian(bigIntegerToByteArray(PUBLIC_KEY));
        System.arraycopy(abyte2, 0, abyte1, 32, 32);
        abyte0 = swapEndian(abyte0);
        BigInteger biginteger = new BigInteger(1, abyte0);
        biginteger = biginteger.modPow(PRIVATE_KEY, GLOBAL_KEY);
        abyte2 = swapEndian(bigIntegerToByteArray(biginteger));
        System.arraycopy(abyte2, 0, abyte1, 64, 32);
        return abyte1;
    }

    public RSA()
    {
    }

    public static final String VERSION = "RSA v2.0 CLIENT";
    public static final int KEY_SIZE = 32;
    private static BigInteger GLOBAL_KEY = new BigInteger(swapEndian("abb27563e0cc985f45ac92c8a75878e94c4203bd8372b9a9ce77d7dffafd1b02"), 16);
    private static BigInteger PUBLIC_KEY = new BigInteger(swapEndian("17cc95a2f29c0c4b84cc2507b99163f78316531702923807565c32c0a37af600"), 16);
    private static BigInteger PRIVATE_KEY = new BigInteger(swapEndian("67a72f5247747ecf77a905f2c5d88b38c4000000000000000000000000000000"), 16);

}
