package jtrek.rmi;

import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;

public class Register {
    public static void main(String[] args) {
	try {
	    System.setSecurityManager(new RMISecurityManager());
	    Properties props = new Properties(); 
	    props.put("java.security.policy", 
		      "/downloads/java/obstrek/jtrek/rmi/policy");
	    ActivationGroupDesc.CommandEnvironment ace = null; 
	    ActivationGroupDesc exampleGroup = new ActivationGroupDesc(props, ace);
	    ActivationGroupID agi = 
		ActivationGroup.getSystem().registerGroup(exampleGroup);
	    String location = "file:/downloads/java/obstrek/";

	    MarshalledObject data = null;
	    ActivationDesc desc = new ActivationDesc 
		(agi, "jtrek.rmi.FactoryImplementation", 
		 location, data);
	
	    // Register with rmid
	    //
	    FactoryInterface fi = (FactoryInterface)Activatable.register(desc);
	    System.out.println("Got the stub for the FactoryInterface");
        
	    // Bind the stub to a name in the registry running on 1099
	    // 
	    Naming.rebind("FactoryImplementation", fi);
	    System.out.println("Exported FactoryImplementation");

	    System.exit(0);
	}
	catch (java.lang.Exception e) {
	    System.out.println(e.getMessage());
	}
    }
}
